WAIT_EVENT_INTERRUPT(9)

NAME
wait_event_interruptible_locked - sleep until a condition gets true

SYNOPSIS

wait_event_interruptible_locked(wq, condition);

ARGUMENTS

wq
    the waitqueue to wait on

condition
    a C expression for the event to wait for

DESCRIPTION

The process is put to sleep (TASK_INTERRUPTIBLE) until the condition evaluates to true or a signal is received. The condition is checked each time the waitqueue wq is woken up.

It must be called with wq.lock being held. This spinlock is unlocked while sleeping but condition testing is done while lock is held and when this macro exits the lock is held.

The lock is locked/unlocked using spin_lock/spin_unlock functions which must match the way they are locked/unlocked outside of this macro.

wake_up_locked has to be called after changing any variable that could change the result of the wait condition.

The function will return -ERESTARTSYS if it was interrupted by a signal and 0 if condition evaluated to true.

COPYRIGHT